(*
 MskEdNew.pas

 Comment in English y en Espaol por supuesto.

 English
 -------------------------------------------------------------------------------
 - Author   : Jose M Gias
 - email    : sigecom@arrakis.es
 - Version  : 1.03
 - Date     : 18.04.98
 - Type     : FreeWare

 - Component enlarged TMaskEdit that and adds the following properties:

   ColorOnFocus    - Back Color when the Edit has the focus

   ColorOnNotFocus - Back Color when the Edit Does not has the focus


   KeyByTab        - Response upon pulsateing a key as if is pulsateed Tabulator
                     to leave of the component happening the focus to the
                     following, with the value of other key.

                     For defect is assigned the standar of Windows Tabulator for
                     to annul it: KeyByTab = #9

                     For example, if we wish that of a TMEditN could be happened
                     the focus to the following object with the Return key, in
                     addition to with the Tabulator, we would put this value to
                     KeyByTab = #13

 ###############################################################################

 To be Freeware, they are not offered guarantees of no class neither are admitted
 claims of no type.

 This component can be used, be distributed and be modified freely for use
 particular or didactic, but not for commercial use. For commercial use be put
 in touch with the author.

 It will be thanked the one which any commentary, alteration or improvement
 introduced in the component is transmitted to the author.

 Espaol
 -------------------------------------------------------------------------------
 - Autor     : Jos.M Gas
 - email     : sigecom@arrakis.es
 - Versin   : 1.03
 - Fecha     : 18.04.98
 - Tipo      : FreeWare

 - Componente TMaskEdit ampliado, que aade las siguientes propiedades:

   ColorOnFocus    - Color de fondo cuando el Edit tiene el Foco

   ColorOnNotFocus - Color de fondo cuando el Edit No tiene el Foco

   KeyByTab        - Respuesta al pulsar una tecla como si se pulsara Tabulador
                     para salir del componente, pasando el foco al siguiente, con
                     el valor de otra tecla.

                     Por defecto se asigna el estandar de Windows Tabulador, para
                     anularlo: KeyByTab = #9

                     Por ejemplo, si deseamos que de un TEditN se pueda pasar el
                     foco al siguiente objeto con la tecla Enter ademas de con
                     el Tabulador, pondriamos esta valor a KeyByTab = #13

 ###############################################################################

 Al ser Freeware, no se ofrecen garantas de ninguna clase, ni se admiten
 reclamaciones de ningun tipo.

 Este componente puede usarse, distribuirse y modificarse libremente para uso
 particular o didctico, pero no para uso comercial. Para uso comercial ponerse
 en contacto con el autor.

 Se agradecer el que cualquier comentario, correccin o mejora introducida en
 el componente se remita al autor.

*)

unit MskEdNew;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Mask;

type
  TMEditN = class(TMaskEdit)
  private
    { Private declarations }
    FOnEnter   : TNotifyEvent;
    FOnExit    : TNotifyEvent;
    FI_Color   : TColor;
    FE_Color   : TColor;
    FKeyTab    : Char;
  protected
    { Protected declarations }
  public
    { Public declarations }
    procedure KeyPress(var Key: Char); override;
    procedure DOEnter; override;
    procedure DOExit ; override;
    constructor Create(AOwner : TComponent); override;
  published
    { Published declarations }
    property  OnEnter: TNotifyEvent read FOnEnter write FOnEnter;
    property  OnExit : TNotifyEvent read FOnExit  write FOnExit;
    property  ColorOnFocus : TColor read FI_Color write FI_Color;
    property  ColorOnNotFocus : TColor read FE_Color write FE_Color;
    property  EditKeyByTab : Char read FKeyTab write FKeyTab;
  end;

procedure Register;

implementation

constructor TMEditN.Create(AOwner : TComponent);
begin
  inherited Create(AOwner);
  ColorOnFocus    := clWhite;
  ColorOnNotFocus := clSilver;
  Color           := ColorOnNotFocus;
  FKeyTab         := #13;
end;

procedure TMEditN.KeyPress(var Key: Char);
var
 {$IFDEF VER100}
  FEditTemp : TCustomForm; {For Delphi 3}
 {$ELSE}
  FEditTemp : TForm;       {For Delphi 1 - 2}
 {$ENDIF}
begin

 if Key = EditKeyByTab then begin
  FEditTemp := GetParentForm(Self);
  SendMessage(FEditTemp.Handle, WM_NEXTDLGCTL, 0, 0);
  Key := #0;
 end;

 if Key <> #0 then inherited KeyPress(Key);
end;

procedure TMEditN.DoEnter;
begin
 {To assign the Color upon receiving the focus
  Asignar el Color al recibir el foco}
 Color := ColorOnFocus;
 if Assigned(FOnEnter) then FOnEnter(Self);
end;

procedure TMEditN.DoExit;
begin
 {To return the color of the fund upon leaving and losing the focus
  Devolver el color del fondo al salir y perder el foco}
 Color := ColorOnNotFocus;

 if Assigned(FOnExit) then FOnExit(Self);
end;

procedure Register;
begin
  RegisterComponents('Additional', [TMEditN]);
end;

end.
